## MMModemSignal

MMModemSignal — The extended Signal interface

## Functions

const gchar * | mm_modem_signal_get_path ()
gchar * | mm_modem_signal_dup_path ()
guint | mm_modem_signal_get_rate ()
guint | mm_modem_signal_get_rssi_threshold ()
gboolean | mm_modem_signal_get_error_rate_threshold ()
MMSignal * | mm_modem_signal_peek_cdma ()
MMSignal * | mm_modem_signal_get_cdma ()
MMSignal * | mm_modem_signal_peek_evdo ()
MMSignal * | mm_modem_signal_get_evdo ()
MMSignal * | mm_modem_signal_peek_gsm ()
MMSignal * | mm_modem_signal_get_gsm ()
MMSignal * | mm_modem_signal_peek_umts ()
MMSignal * | mm_modem_signal_get_umts ()
MMSignal * | mm_modem_signal_peek_lte ()
MMSignal * | mm_modem_signal_get_lte ()
MMSignal * | mm_modem_signal_peek_nr5g ()
MMSignal * | mm_modem_signal_get_nr5g ()
void | mm_modem_signal_setup ()
gboolean | mm_modem_signal_setup_finish ()
gboolean | mm_modem_signal_setup_sync ()
void | mm_modem_signal_setup_thresholds ()
gboolean | mm_modem_signal_setup_thresholds_finish ()
gboolean | mm_modem_signal_setup_thresholds_sync ()

## Types and Values

struct | MMModemSignal

## Object Hierarchy

        GObject
        ╰── GDBusProxy
            ╰── MmGdbusModemSignalProxy
                ╰── MMModemSignal

## Implemented Interfaces

MMModemSignal implements GDBusInterface, GInitable, GAsyncInitable and MmGdbusModemSignal.

## Description

The MMModemSignal is an object providing access to the methods, signals and properties of the Signal interface.

The Signal interface is exposed whenever a modem has extended signal retrieval capabilities.

## Functions

### mm_modem_signal_get_path ()

    const gchar *
    mm_modem_signal_get_path (MMModemSignal *self);

Gets the DBus path of the MMObject which implements this interface.

#### Parameters

self | A MMModemSignal. |

#### Returns

The DBus path of the MMObject object.

[transfer none]

Since: 1.2

### mm_modem_signal_dup_path ()

    gchar *
    mm_modem_signal_dup_path (MMModemSignal *self);

Gets a copy of the DBus path of the MMObject object which implements this interface.

#### Parameters

self | A MMModemSignal. |

#### Returns

The DBus path of the MMObject. The returned value should be freed with `g_free()`.

[transfer full]

Since: 1.2

### mm_modem_signal_get_rate ()

    guint
    mm_modem_signal_get_rate (MMModemSignal *self);

Gets the currently configured refresh rate.

#### Parameters

self | A MMModemSignal. |

#### Returns

the refresh rate, in seconds.

Since: 1.2

### mm_modem_signal_get_rssi_threshold ()

    guint
    mm_modem_signal_get_rssi_threshold (MMModemSignal *self);

Gets the currently configured RSSI threshold, in dBm.

A value of 0 indicates the threshold is disabled.

#### Parameters

self | A MMModemSignal. |

#### Returns

the RSSI threshold.

Since: 1.20

### mm_modem_signal_get_error_rate_threshold ()

    gboolean
    mm_modem_signal_get_error_rate_threshold
                                   (MMModemSignal *self);

Gets whether the error rate threshold is enabled or not.

#### Parameters

self | A MMModemSignal. |

#### Returns

`TRUE` if the error rate threshold is enabled, `FALSE` otherwise.

Since: 1.20

### mm_modem_signal_peek_cdma ()

    MMSignal *
    mm_modem_signal_peek_cdma (MMModemSignal *self);

Gets a MMSignal object specifying the CDMA signal information.

The returned value is only valid until the property changes so it is only safe to use this function on the thread where `self` was constructed. Use `mm_modem_signal_get_cdma()` if on another thread.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal. Do not free the returned value, it belongs to `self` .

[transfer none]

Since: 1.2

### mm_modem_signal_get_cdma ()

    MMSignal *
    mm_modem_signal_get_cdma (MMModemSignal *self);

Gets a MMSignal object specifying the CDMA signal information.

The values reported by `self` are not updated when the values in the interface change. Instead, the client is expected to call `mm_modem_signal_get_cdma()` again to get a new MMSignal with the new values.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal that must be freed with `g_object_unref()` or `NULL` if unknown.

[transfer full]

Since: 1.2

### mm_modem_signal_peek_evdo ()

    MMSignal *
    mm_modem_signal_peek_evdo (MMModemSignal *self);

Gets a MMSignal object specifying the EV-DO signal information.

The returned value is only valid until the property changes so it is only safe to use this function on the thread where `self` was constructed. Use `mm_modem_signal_get_evdo()` if on another thread.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal. Do not free the returned value, it belongs to `self` .

[transfer none]

Since: 1.2

### mm_modem_signal_get_evdo ()

    MMSignal *
    mm_modem_signal_get_evdo (MMModemSignal *self);

Gets a MMSignal object specifying the EV-DO signal information.

The values reported by `self` are not updated when the values in the interface change. Instead, the client is expected to call `mm_modem_signal_get_evdo()` again to get a new MMSignal with the new values.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal that must be freed with `g_object_unref()` or `NULL` if unknown.

[transfer full]

Since: 1.2

### mm_modem_signal_peek_gsm ()

    MMSignal *
    mm_modem_signal_peek_gsm (MMModemSignal *self);

Gets a MMSignal object specifying the GSM signal information.

The returned value is only valid until the property changes so it is only safe to use this function on the thread where `self` was constructed. Use `mm_modem_signal_get_gsm()` if on another thread.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal. Do not free the returned value, it belongs to `self` .

[transfer none]

Since: 1.2

### mm_modem_signal_get_gsm ()

    MMSignal *
    mm_modem_signal_get_gsm (MMModemSignal *self);

Gets a MMSignal object specifying the GSM signal information.

The values reported by `self` are not updated when the values in the interface change. Instead, the client is expected to call `mm_modem_signal_get_gsm()` again to get a new MMSignal with the new values.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal that must be freed with `g_object_unref()` or `NULL` if unknown.

[transfer full]

Since: 1.2

### mm_modem_signal_peek_umts ()

    MMSignal *
    mm_modem_signal_peek_umts (MMModemSignal *self);

Gets a MMSignal object specifying the UMTS signal information.

The returned value is only valid until the property changes so it is only safe to use this function on the thread where `self` was constructed. Use `mm_modem_signal_get_umts()` if on another thread.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal. Do not free the returned value, it belongs to `self` .

[transfer none]

Since: 1.2

### mm_modem_signal_get_umts ()

    MMSignal *
    mm_modem_signal_get_umts (MMModemSignal *self);

Gets a MMSignal object specifying the UMTS signal information.

The values reported by `self` are not updated when the values in the interface change. Instead, the client is expected to call `mm_modem_signal_get_umts()` again to get a new MMSignal with the new values.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal that must be freed with `g_object_unref()` or `NULL` if unknown.

[transfer full]

Since: 1.2

### mm_modem_signal_peek_lte ()

    MMSignal *
    mm_modem_signal_peek_lte (MMModemSignal *self);

Gets a MMSignal object specifying the LTE signal information.

The returned value is only valid until the property changes so it is only safe to use this function on the thread where `self` was constructed. Use `mm_modem_signal_get_lte()` if on another thread.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal. Do not free the returned value, it belongs to `self` .

[transfer none]

Since: 1.2

### mm_modem_signal_get_lte ()

    MMSignal *
    mm_modem_signal_get_lte (MMModemSignal *self);

Gets a MMSignal object specifying the LTE signal information.

The values reported by `self` are not updated when the values in the interface change. Instead, the client is expected to call `mm_modem_signal_get_lte()` again to get a new MMSignal with the new values.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal that must be freed with `g_object_unref()` or `NULL` if unknown.

[transfer full]

Since: 1.2

### mm_modem_signal_peek_nr5g ()

    MMSignal *
    mm_modem_signal_peek_nr5g (MMModemSignal *self);

Gets a MMSignal object specifying the 5G signal information.

The returned value is only valid until the property changes so it is only safe to use this function on the thread where `self` was constructed. Use `mm_modem_signal_get_nr5g()` if on another thread.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal. Do not free the returned value, it belongs to `self` .

[transfer none]

Since: 1.16

### mm_modem_signal_get_nr5g ()

    MMSignal *
    mm_modem_signal_get_nr5g (MMModemSignal *self);

Gets a MMSignal object specifying the 5G signal information.

The values reported by `self` are not updated when the values in the interface change. Instead, the client is expected to call `mm_modem_signal_get_nr5g()` again to get a new MMSignal with the new values.

#### Parameters

self | A MMModem. |

#### Returns

A MMSignal that must be freed with `g_object_unref()` or `NULL` if unknown.

[transfer full]

Since: 1.16

### mm_modem_signal_setup ()

    void
    mm_modem_signal_setup (MMModemSignal *self,
                           guint rate,
                           GCancellable *cancellable,
                           GAsyncReadyCallback callback,
                           gpointer user_data);

Asynchronously enables or disables the extended signal quality information retrieval via periodic polling.

When the operation is finished, `callback` will be invoked in the

thread-default main loop

of the thread you are calling this method from. You can then call `mm_modem_signal_setup_finish()` to get the result of the operation.

See `mm_modem_signal_setup_sync()` for the synchronous, blocking version of this method.

#### Parameters

self | A MMModemSignal. |
rate | Refresh rate to set, in seconds. Use 0 to disable periodic polling. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 1.2

### mm_modem_signal_setup_finish ()

    gboolean
    mm_modem_signal_setup_finish (MMModemSignal *self,
                                  GAsyncResult *res,
                                  GError **error);

Finishes an operation started with `mm_modem_signal_setup()`.

#### Parameters

self | A MMModemSignal. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_modem_signal_setup()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the setup was successful, `FALSE` if `error` is set.

Since: 1.2

### mm_modem_signal_setup_sync ()

    gboolean
    mm_modem_signal_setup_sync (MMModemSignal *self,
                                guint rate,
                                GCancellable *cancellable,
                                GError **error);

Synchronously enables or disables the extended signal quality information retrieval via periodic polling.

The calling thread is blocked until a reply is received. See `mm_modem_signal_setup()` for the asynchronous version of this method.

#### Parameters

self | A MMModemSignal. |
rate | Refresh rate to set, in seconds. Use 0 to disable periodic polling. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the setup was successful, `FALSE` if `error` is set.

Since: 1.2

### mm_modem_signal_setup_thresholds ()

    void
    mm_modem_signal_setup_thresholds (MMModemSignal *self,
                                      MMSignalThresholdProperties *properties,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

Asynchronously setups thresholds so that the device itself decides when to report the extended signal quality information updates.

When the operation is finished, `callback` will be invoked in the

thread-default main loop

of the thread you are calling this method from. You can then call `mm_modem_signal_setup_thresholds_finish()` to get the result of the operation.

See `mm_modem_signal_setup_thresholds_sync()` for the synchronous, blocking version of this method.

#### Parameters

self | A MMModemSignal. |
properties | Threshold values to set. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 1.20

### mm_modem_signal_setup_thresholds_finish ()

    gboolean
    mm_modem_signal_setup_thresholds_finish
                                   (MMModemSignal *self,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_modem_signal_setup_thresholds()`.

#### Parameters

self | A MMModemSignal. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_modem_signal_setup_thresholds()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the setup was successful, `FALSE` if `error` is set.

Since: 1.20

### mm_modem_signal_setup_thresholds_sync ()

    gboolean
    mm_modem_signal_setup_thresholds_sync (MMModemSignal *self,
                                           MMSignalThresholdProperties *properties,
                                           GCancellable *cancellable,
                                           GError **error);

Synchronously setups thresholds so that the device itself decides when to report the extended signal quality information updates.

The calling thread is blocked until a reply is received. See `mm_modem_signal_setup_thresholds()` for the asynchronous version of this method.

#### Parameters

self | A MMModemSignal. |
properties | Threshold values to set. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the setup was successful, `FALSE` if `error` is set.

Since: 1.20

## Types and Values

### struct MMModemSignal

    struct MMModemSignal;

The MMModemSignal structure contains private data and should only be accessed using the provided API.